#include<bits/stdc++.h>
using namespace std;
constexpr int N=100;
char ch[N+10][N+10];
int main(){
	int T,Tid;
	cin>>T>>Tid;
	while(T--){
		int n,m,c,f;
		cin>>n>>m>>c>>f;
		int i,j,i1,i2,i3,k,l;
		for(i=1;i<=n;++i) cin>>ch[i]+1;
		int ansc=0,ansf=0;
		for(i=1;i<=n;++i){
			for(j=i+2;j<=n;++j){
				for(i1=1;i1<=m;++i1){
					for(i2=i1+1;i2<=m;++i2){
						for(i3=i1+1;i3<=m;++i3){
							bool flag=1;
							for(l=i;l<=j;++l) if(ch[l][i1]=='1') flag=0;
							for(l=i1;l<=i2;++l) if(ch[i][l]=='1') flag=0;
							for(l=i1;l<=i3;++l) if(ch[j][l]=='1') flag=0;
							if(!flag) continue;
							ansc+=c;
							for(l=j+1;l<=n;++l){
								if(ch[l][i1]=='1') break;
								ansf+=f;
							}
						}
					}
				}
			}
		}
		cout<<ansc<<' '<<ansf<<'\n';
	}
	return 0;
}
